#import <stdio.h>
#import <time.h>
#import <math.h>
#import <mach/mach.h>
#import <Cocoa/Cocoa.h>
#import <CoreFoundation/CFNumber.h>
#import <IOKit/IOKitLib.h>
#import <IOKit/IOCFPlugIn.h>
#import <IOKit/usb/IOUSBLib.h>


@interface Friio : NSObject {
	mach_port_t				masterPort;
    io_service_t			usbDeviceRef;
	io_service_t			usbInterfaceRef;
	IOUSBDeviceInterface	**dev;
	IOUSBInterfaceInterface	**interface;
	const char				*file_path;
}

// レスポンス構造体
typedef struct{
	IOUSBInterfaceInterface	**interface;
	UInt8					buffer[327680];
	FILE					*fd;
} USBResponse;

// インスタンスメソッド
- (int)open;
- (int)_findDevice;
- (int)_findInterface;
- (int)_setupInterface;
- (int)close;

- (int)_sendRequest:(UInt16)wValue withIndex:(UInt16)wIndex;
- (int)initStageA;
- (int)initStageB;
- (int)initStream;

- (int)rec:(char*)file withTime:(int)rec_sec;
- (void)_recWorker:(id)obj;

- (int)setChannel:(int)channel;
- (float)getSignalLevel;
- (void)setLED:(int)color;

// コールバック関数
void _workerCallback(USBResponse *readRes, IOReturn result, void *arg);

@end
